Keyboard shortcuts - Update some window management shortcuts to use "Ctrl + Super" instead of just "Super"

Bug #969235 reported by John Lea on 2012-03-30
10
This bug affects 1 person
Affects Status Importance Assigned to Milestone
Ayatana Design
Critical
John Lea
compiz (Ubuntu)
Undecided
Didier Roche
compiz-plugins-main (Ubuntu)
Undecided
Didier Roche
metacity (Ubuntu)
Undecided
Didier Roche
ubuntu-docs (Ubuntu)
Undecided
Unassigned

Bug Description

Change the following window management shortcuts

from:

Ctrl + Alt + D Minimises all windows
Super + Cursor up Maximises the current window
Super + Cursor down Restores or minimises current window
Super + Cursor Left or Right Semi-maximises current window

to:

Ctrl + Super + D Minimises all windows
Ctrl + Super + Cursor up Maximises the current window
Ctrl + Super + Cursor down Restores or minimises current window
Ctrl + Super + Cursor Left or Right Semi-maximises current window

Rational:

SUPER triggers the launcher, and the actions listed above do not require launcher interactions. As a result, using SUPER on it's own for these interactions has resulted in false positives where the launcher is revealed even though it provides no benefit for these interactions. Adding CTRL to the beginning of these shortcuts solves this problem, and also makes the shortcuts more congruous with the 'Ctrl + Alt + Cursor Keys' workspace shortcuts.

For a full list of the unity shortcuts see https://docs.google.com/a/canonical.com/document/d/1jqeKtIJwqLtl58Wk_fqjr9Rrgxn9zsouCYOo-cZsLSE/edit

John Lea (johnlea) on 2012-03-30
description: updated
Changed in ayatana-design:
assignee: nobody → John Lea (johnlea)
importance: Undecided → Critical
status: New → Triaged
Changed in unity:
status: New → Confirmed
Changed in unity (Ubuntu):
status: New → Confirmed
Changed in unity:
milestone: none → backlog
tags: added: keybinding udp
Gerry Boland (gerboland) on 2012-03-30
Changed in unity-2d:
milestone: none → 5.10.0
status: New → Confirmed
Changed in unity-2d (Ubuntu):
status: New → Confirmed
Jeremy Bicha (jbicha) wrote :

This of course is going to need UIFe approval, especially as it will need a Docs String Freeze Exception.

I admit I'm a bit skeptical about this change. Keyboard shortcut users probably don't like their keyboard shortcuts changing without a good reason, so the question is whether this is actually a good reason and if it has been thought through enough.

For instance, it shouldn't matter the order in which the keys are pressed. Ctrl + Super + D should do the same thing as Super + Ctrl + D and it sounds like the designers and developers don't expect this to work (whether by design or by accident). Maybe releated to bug 964571 about Shift+Alt+Tab only working in Alt+Tab mode.

I suppose the keyboard shortcut hint overlay does help in mitigating the impact of the change.

Didier Roche (didrocks) wrote :

@Jeremy: this doesn't impact the translations themselves. However, I spotted another translation issue related to this dialog.

Didier Roche (didrocks) on 2012-04-02
affects: unity → compiz
Changed in compiz:
milestone: backlog → none
affects: compiz → compiz-core
Didier Roche (didrocks) on 2012-04-02
no longer affects: compiz-core
no longer affects: unity-2d (Ubuntu)
no longer affects: unity-2d
affects: unity (Ubuntu) → compiz (Ubuntu)
Changed in compiz-plugins-main (Ubuntu):
status: New → Confirmed
Changed in metacity (Ubuntu):
status: New → Confirmed
Changed in compiz (Ubuntu):
assignee: nobody → Didier Roche (didrocks)
Changed in compiz-plugins-main (Ubuntu):
assignee: nobody → Didier Roche (didrocks)
Changed in metacity (Ubuntu):
assignee: nobody → Didier Roche (didrocks)
Yann Dìnendal (yannbreliere) wrote :

This would break the behavior both for windows users used to Super+D and for old Ubuntu users used to Ctrl+Alt+D.

Jeremy Bicha (jbicha) wrote :

Didier, it might not affect compiz/unity translations, but it will require a freeze exception for ubuntu-docs translations.

I don't object to bugfixes, but I am concerned that this could be a case where one bug is fixed and another is created. No one expects these new keyboard shortcuts, but a fair amount of people have gotten used to the existing shortcuts.

Didier Roche (didrocks) wrote :

@Jeremy: oh, I totally agree, that's why when John came with that last Friday, I asked him to file turns this bug as an UIE. He sent some emails already to the doc team already from what I know.

Jeremy Bicha (jbicha) wrote :

John Lea pointed out in chat today that except for the Show Desktop shortcut, the other keyboard shortcuts mentioned in the bug are new to 12.04 so there is no regression (except for beta users). I'll give my +1 from the Docs Team for those. I'll have to talk with dpm to see if this is something we can change in ubuntu-docs now or if we need to wait for the first SRU.

I'm not convinced yet about the Show Desktop shortcut changing though. I think people expect either Ctrl+Alt+D (which has been used in Ubuntu pretty consistently for quite a while and is the current default) or Super+D (what Windows does). I hesitate to give a +1 for this change as I don't know if our keyboard shortcut users will appreciate the change this late in the release cycle.

John also said "Basically we want to end up with all the window shortcuts starting with CTRL+SUPER and all the workspace shortcuts starting with CTRL+ALT." He further made the point that if shortcuts are going to change, it is better to do them before the LTS which is reasonable.

Jeremy Bicha (jbicha) wrote :

I'll give the Show Desktop change a +1 too. I think most keyboard shortcut users would rather have that shortcut change once and for all. If Design is sure this is what it should be, let's go with it.

It's not really what people expect, but I'd probably be overstepping my Docs Team role to be a blocker for it.

Jeremy Bicha (jbicha) on 2012-04-03
description: updated
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package compiz - 1:0.9.7.4-0ubuntu1

---------------
compiz (1:0.9.7.4-0ubuntu1) precise; urgency=low

  * New upstream release
    - compiz crashed with SIGSEGV in CompositeScreen::compositingActive()
    - Window management - Closing one window sends others to the
      background (LP: #888704)
    - [regression] Invisible resize border is now only 1px wide (LP: #953839)
    - Coverity REVERSE_INULL - CID 10888 (LP: #957572)
    - Unity dash opens and immediately closes if you tap Super+A
      quickly (LP: #960831)
    - Unity 5.8: Flickering and corruption on Unity UI elements (LP: #963093)
    - Unity 5.8: Can't login to Unity since upgrade to 5.8 (LP: #963465)
    - [regression] Unity 5.8+Compiz 0.9.7.2: Pressing Super+Tab or
      Super+W works, but unity does not respond to when Super is
      released. (LP: #963470)
    - Unity 5.8: Login to blank screen (all black or just wallpaper)
      (LP: #963633)
    - Tests do not build when libgtest-dev is installed but libgtest
      isn't (LP: #964248)
    - Note that this fix is REMOVED for stability reasons:
       Unity/compiz intercepts Super and Alt keypresses from grabbed
       windows like VMs. (806255)
  * debian/patches/ubuntu-config.patch:
    - tweak slightly the shadow border for both active/inactive windows.
    - change the shortcuts as per design request: (LP: #969235)
      Ctrl + Super + D Minimises all windows
      Ctrl + Super + Cursor up Maximises the current window
      Ctrl + Super + Cursor down Restores or minimises current window
  * debian/rules, debian/compiz-gnome.gconf-defaults:
    - move the default for the unity-less default profile from DEFAULT_PLUGINS
      list as it seems compiz tries to load that list, then ccp, then the
      profile list.
    - put the active_plugins list back to the Default profile in gconf then.
  * debian/control:
    - set Standards-Version to latest
  * remove debian/patches/always_replace.patch,
    debian/patches/exit_1_if_composite_cant_init.patch,
    debian/patches/reset_active_plugin_list.patch,
    debian/reset-compiz-gconf, debian/compiz-gnome.install:
    - the 3 bad hacks are now not necessary anymore (LP: #963264)
  * remove as now in upstream tarball:
    - debian/patches/fix_953839.patch
    - debian/patches/revert_lim.patch
    - debian/patches/fix_953089_2.patch
    - debian/patches/fix_960831.patch
 -- Didier Roche <email address hidden> Tue, 03 Apr 2012 15:43:16 +0200

Changed in compiz (Ubuntu):
status: Confirmed → Fix Released
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package compiz-plugins-main - 1:0.9.7.0~bzr19-0ubuntu8

---------------
compiz-plugins-main (1:0.9.7.0~bzr19-0ubuntu8) precise; urgency=low

  [ Matthias Niess]
  * debian/patchs/ubuntu-config.patch:
    - disable ezoom bad default of Super+r causing zoom to current window
      (LP: #953278)

  [ Didier Roche ]
  * debian/patches/ubuntu_config.patch: (LP: #969235)
    - update shortcuts per design request:
      Ctrl + Super + Cursor Left or Right Semi-maximises current window
 -- Didier Roche <email address hidden> Tue, 03 Apr 2012 15:45:04 +0200

Changed in compiz-plugins-main (Ubuntu):
status: Confirmed → Fix Released
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package metacity - 1:2.34.1-1ubuntu10

---------------
metacity (1:2.34.1-1ubuntu10) precise; urgency=low

  * debian/metacity-common.gconf-defaults:
    - change the shortcuts as per design request: (LP: #969235)
      Ctrl + Super + D Minimises all windows
      Ctrl + Super + Cursor up Maximises the current window
      Ctrl + Super + Cursor down Restores or minimises current window
 -- Didier Roche <email address hidden> Tue, 03 Apr 2012 15:46:50 +0200

Changed in metacity (Ubuntu):
status: Confirmed → Fix Released
Logan Rosen (logan) wrote :

Not sure that this fix worked completely. "Ctrl + Super + D Minimises all windows" and "Ctrl + Super + Cursor Left or Right Semi-maximises current window" don't seem to work with the latest updates, but the old shortcuts still work for those.

Andy Whitcroft (apw) wrote :

It should also be noted that a Ctrl+Super+<x> keybinding implies both of the prefix characters pressed together and then the additional key, and that depending which of Super and Ctrl contacts first depends on whether the launcher is triggered falsely. We should consider the super as part of a key combination if any other modifier is added very soon after it is triggered (in human terms).

Jeremy Bicha (jbicha) wrote :

One thing that I didn't fully realize until today:

Both GNOME Shell & Windows 7 use Super+Left/Right to half-maximize. I think the Design Team needs to carefully consider whether breaking keyboard shortcut compatibility with other desktops is worth it.

I think I'll change the Ubuntu GNOME Shell shortcuts to match since it's really just gsettings shortcuts and Unity will be switching to gsettings (maybe for 12.10?) and I think Unity/Compiz should avoid reinventing shortcuts if they're already supplied by gsettings-desktop-schemas. Doing that will still lose compatibility with GNOME Shell on other Linux distributions.

Jean-Paul (jeanpaul145) wrote :

Though I can't speak for others, personally I don't mind the change itself. However, the vertical "half-maximalisation" keybindings (which I'll define as maximalisation such that you can put 2 windows next to each other), as you guys call it should be consistent with both the horizontal (one window op top of another) and the quadrant (making a window occupy a quarter of the screen) half-maximalisation keys, in keeping with basic convenience rules and the rule of least surprise.

I'm writing this using the AMD daily Live CD of April 6, and I can tell you guys that currently, they're not consistent, which is counter-intuitive, and that in turn seems to clash with what I perceive to be a core value of Unity: user-friendliness.
Horizontal half-maximalisation right now is bound to <ctrl> + <alt> + <kp up> and <ctrl> + <alt> + <kp down>, but because of this change, vertical half-maximalisation is bound to <ctrl> + <alt> + <left> and <ctrl> + <alt> + <right> instead of <ctrl> + <alt> + <kp left> and <ctrl> + <alt> + <kp right>.

As a very frequent user of this feature, I'd like to see this to be made consistent, ideally (though of course not necessarily) in such a way my fingers never need to leave the home row of my keyboard.

I wasn't intending to discuss this here, but as that is already sort-of done, I'll also give you guys my opinion of the "keybinding help overview" that's bound to "hold <super>":
First off, it's really great it's there as it's quick, contains useful information and doesn't get in the way of the user's workflow, but it has some layouting issues (not being able to see a keybinding in full makes such an entry effectively useless, requiring a google search), which can be corrected by utilising the available space better. A lot of it is currently wasted.
Secondly, the overview needs to become more discoverable. I stumbled on it entirely by accident when I was, for the first time ever, playing around with the dash and HUD to get an impression of Unity.

Jean-Paul (jeanpaul145) wrote :

Apologies, I see I've made a mistake (pity the last post in a thread here isn't editable by its author). Vertical half-maximalisation is of course bound to <ctrl> + <super> + <left> and <ctrl> + <super> + <right>, not <ctrl> + <alt> + <left> and <ctrl> + <alt> + <right>.

Tim Penhey (thumper) on 2012-04-16
Changed in ayatana-design:
status: Triaged → Fix Committed
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package ubuntu-docs - 12.04.4

---------------
ubuntu-docs (12.04.4) precise; urgency=low

  * Finalize screenshots for Ubuntu 12.04
  * Fix missing keyboard shortcuts page
  * Refer to the Windows key as the Super key instead of the meta key
  * Update for new Unity Ctrl+Super keyboard shortcuts (LP: #969235)
 -- Jeremy Bicha <email address hidden> Wed, 04 Apr 2012 09:13:40 -0400

Changed in ubuntu-docs (Ubuntu):
status: New → Fix Released
John Lea (johnlea) wrote :

This bug is only partially fixed, I have opened a new bug with the remaining issues. See https://bugs.launchpad.net/ubuntu/+source/unity/+bug/988997

tags: added: reviewedbydesignp
removed: udp
Changed in ayatana-design:
status: Fix Committed → Fix Released
To post a comment you must log in.
This report contains Public information  Edit
Everyone can see this information.

Other bug subscribers